SET FEEDBACK OFF
CREATE VIEW ALL_ATTRIBUTES AS
(
  SELECT B.ENTITY_DEF_S, A.PARENT_ENT ENTITY_DEF_NM, A.AGGR_NAME,
	 A.ATTRIBUTE_NM, A.ATTRIBUTE_S, A.ENT_OR_TYPE_CODE, A.ENT_OR_TYPE_NM,
	 A.FIXED_LENGTH, A.FORWARD_S, A.IS_ACTIVE, A.MAX_CARD, A.MAX_LENGTH,
	 A.MIN_CARD, A.OPTIONALITY, A.ORIG_CARD, A.PARENT_ENT, A.REDECL_ENT_S,
	 A.SOURCE_S, A.VERB_PHRASE
  FROM   ATTRIBUTE A, ENTITY_DEF B
  WHERE  B.ENTITY_DEF_NM = A.PARENT_ENT
  UNION
  SELECT D.ENTITY_DEF_S, D.ENTITY_DEF_NM ENTITY_DEF_NM, A.AGGR_NAME,
	 A.ATTRIBUTE_NM, A.ATTRIBUTE_S, A.ENT_OR_TYPE_CODE, A.ENT_OR_TYPE_NM,
	 A.FIXED_LENGTH, A.FORWARD_S, A.IS_ACTIVE, A.MAX_CARD, A.MAX_LENGTH,
	 A.MIN_CARD, A.OPTIONALITY, A.ORIG_CARD, A.PARENT_ENT, A.REDECL_ENT_S,
	 A.SOURCE_S, A.VERB_PHRASE
  FROM   ENTITY_DEF D, ENTITY_DEF C, SUPERSUB B, ATTRIBUTE A
  WHERE  A.PARENT_ENT = C.ENTITY_DEF_NM
  AND    B.ORIGIN_S = C.ENTITY_DEF_S
  AND    B.SUB_S = D.ENTITY_DEF_S
);
CREATE VIEW ENTITY_UNIQUE AS
(
  SELECT A.ENTITY_DEF_NM FROM_ENTITY_DEF_NM,
         A.ENTITY_DEF_S FROM_ENTITY_DEF_S,
         A.ENTITY_DEF_NM, A.ENTITY_DEF_S,
	 B.PARENT_ENT,
         B.ATTRIBUTE_NM, B.ATTRIBUTE_S,
         C.RULES_S, C.RULE_LABEL, C.SOURCE_S,
	 C.REF_RULE_TYPE
  FROM   ENTITY_DEF A, ATTRIBUTE B, RULES C
  WHERE  B.ATTRIBUTE_S = C.ATTRIBUTE_S
  AND    C.ENT_OR_TYPE_S = A.ENTITY_DEF_S
  AND    C.RULE_TYPE = 'UNR'
  UNION
  SELECT E.ENTITY_DEF_NM FROM_ENTITY_DEF_NM,
         E.ENTITY_DEF_S FROM_ENTITY_DEF_S,
         A.ENTITY_DEF_NM, A.ENTITY_DEF_S,
	 B.PARENT_ENT,
         B.ATTRIBUTE_NM, B.ATTRIBUTE_S,
         C.RULES_S, C.RULE_LABEL, C.SOURCE_S,
	 C.REF_RULE_TYPE
  FROM   ENTITY_DEF A, ATTRIBUTE B, RULES C, SUPERSUB D,
         ENTITY_DEF E
  WHERE  B.ATTRIBUTE_S = C.ATTRIBUTE_S
  AND    A.ENTITY_DEF_S = D.SUB_S
  AND    D.ORIGIN_S = E.ENTITY_DEF_S
  AND    C.ENT_OR_TYPE_S = D.ORIGIN_S
  AND    C.RULE_TYPE = 'UNR'
);
CREATE VIEW ENTITY_WHERE AS
(
  SELECT A.ENTITY_DEF_NM FROM_ENTITY_DEF_NM,
         A.ENTITY_DEF_S FROM_ENTITY_DEF_S,
         A.ENTITY_DEF_NM, A.ENTITY_DEF_S,
         B.RULE_TEXT, B.RULES_S, B.RULE_LABEL,
	 B.REF_RULE_TYPE
  FROM   ENTITY_DEF A, RULES B
  WHERE  B.ENT_OR_TYPE_S = A.ENTITY_DEF_S
  AND    B.RULE_TYPE = 'ENT'
  UNION
  SELECT D.ENTITY_DEF_NM FROM_ENTITY_DEF_NM,
         D.ENTITY_DEF_S FROM_ENTITY_DEF_S,
         A.ENTITY_DEF_NM, A.ENTITY_DEF_S,
         B.RULE_TEXT, B.RULES_S, B.RULE_LABEL,
	 B.REF_RULE_TYPE
  FROM   ENTITY_DEF A, RULES B, SUPERSUB C,
         ENTITY_DEF D
  WHERE  C.ORIGIN_S = D.ENTITY_DEF_S
  AND    A.ENTITY_DEF_S = C.SUB_S
  AND    B.ENT_OR_TYPE_S = C.ORIGIN_S
  AND    B.RULE_TYPE = 'ENT'
);
CREATE VIEW TYPE_WHERE AS
(
  SELECT A.TYPE_DEF_NM, A.TYPE_DEF_S, B.RULE_TEXT,
	 B.RULES_S, B.RULE_LABEL, A.SOURCE_S,
	 B.REF_RULE_TYPE
  FROM   TYPE_DEF A, RULES B
  WHERE  B.ENT_OR_TYPE_S = A.TYPE_DEF_S
  AND    B.RULE_TYPE = 'TYP'
);
CREATE VIEW ENTITY_SUPER AS
(
  SELECT A.ENTITY_DEF_S, A.ENTITY_DEF_NM, B.ORIGIN_S,
	 C.ENTITY_DEF_NM SUPER_NM
  FROM   ENTITY_DEF A, SUPERSUB B, ENTITY_DEF C
  WHERE  C.ENTITY_DEF_S = B.ORIGIN_S
  AND    A.ENTITY_DEF_S = B.SUB_S
);
CREATE VIEW ENTITY_SUB AS
(
  SELECT A.ENTITY_DEF_S, A.ENTITY_DEF_NM, B.SUB_S,
	 C.ENTITY_DEF_NM SUB_NM
  FROM   ENTITY_DEF A, SUPERSUB B, ENTITY_DEF C
  WHERE  C.ENTITY_DEF_S = B.SUB_S
  AND    A.ENTITY_DEF_S = B.ORIGIN_S
);
CREATE VIEW ENTITY_SUPERSUB AS
(
  SELECT A.ENTITY_DEF_NM ORIGIN_NM, D.ORIGIN_S,
	 B.ENTITY_DEF_NM SUPER_NM, D.SUPER_S,
	 C.ENTITY_DEF_NM SUB_NM, D.SUB_S
  FROM   ENTITY_DEF A, ENTITY_DEF B, ENTITY_DEF C,
	 SUPERSUB D
  WHERE  A.ENTITY_DEF_S = D.ORIGIN_S
  AND    B.ENTITY_DEF_S = D.SUPER_S
  AND    C.ENTITY_DEF_S = D.SUB_S
);
CREATE VIEW ATTRIBUTE_COLUMN AS
(
  SELECT A.ENTITY_DEF_NM, A.ENTITY_DEF_S,
         A.ATTRIBUTE_S, A.ATTRIBUTE_NM,
         B.REF_PROJ_METH, C.COLUMN_DEF_S, C.COLUMN_DEF_NM,
         C.PARENT_TABLE_S, D.TABLE_DEF_NM PARENT_TABLE_NM
  FROM   ALL_ATTRIBUTES A, ATT_COL_GRP_MAP B, COLUMN_DEF C,
         TABLE_DEF D, COLUMN_GROUP E
  WHERE  A.ATTRIBUTE_S = B.ATTRIBUTE_S
  AND    B.COLUMN_GROUP_S = E.HEAD_COL_GRP_S
  AND    C.COLUMN_DEF_S = E.COLUMN_DEF_S
  AND    D.TABLE_DEF_S = C.PARENT_TABLE_S
  AND    E.REF_COLUMN_GRP_KD = 'att_proj'
);
CREATE VIEW INV_ATTRIBUTE_COLUMN AS
(
  SELECT A.ENTITY_DEF_NM, A.ENTITY_DEF_S,
         A.ATTRIBUTE_S, A.ATTRIBUTE_NM,
         B.REF_PROJ_METH, C.COLUMN_DEF_S, C.COLUMN_DEF_NM,
         C.PARENT_TABLE_S, D.TABLE_DEF_NM PARENT_TABLE_NM
  FROM   ALL_ATTRIBUTES A, ATT_COL_GRP_MAP B, COLUMN_DEF C,
         TABLE_DEF D, COLUMN_GROUP E
  WHERE  A.FORWARD_S = B.ATTRIBUTE_S
  AND    B.COLUMN_GROUP_S = E.HEAD_COL_GRP_S
  AND    C.COLUMN_DEF_S = E.COLUMN_DEF_S
  AND    D.TABLE_DEF_S = C.PARENT_TABLE_S
  AND    E.REF_COLUMN_GRP_KD = 'att_proj'
);
CREATE VIEW ENTITY_TABLE AS
(
  SELECT A.ENTITY_DEF_NM, A.ENTITY_DEF_S,
         B.TABLE_DEF_S, B.TABLE_DEF_NM, B.TABLE_TYPE,
         C.REF_PROJ_METH, A.IS_ABSTRACT
  FROM   ENTITY_DEF A, TABLE_DEF B, PROJECTION_MAP C
  WHERE  C.REF_PROJ_METH IN
            ('ent_table','ent_consol',
             'ent_replic','ent_n_in_one',
	     'ent_replic_consol')
  AND    B.TABLE_DEF_S = C.MAP_TARGET_S
  AND    A.ENTITY_DEF_S = C.MAP_SOURCE_S
);
CREATE VIEW ENTITY_DESC AS
(
  SELECT A.SOURCE_S, A.ENTITY_DEF_S, A.ENTITY_DEF_NM,
         C.DESCRIPTION_TEXT
  FROM   ENTITY_DEF A, OBJ_DESC B,
         DESCRIPTION C
  WHERE  B.OBJECT_T = 'ENT'
  AND    B.OBJECT_S = A.ENTITY_DEF_S
  AND    C.DESCRIPTION_S = B.DESCRIPTION_S
);
CREATE VIEW TYPE_DESC AS
(
  SELECT A.SOURCE_S, A.TYPE_DEF_S, A.TYPE_DEF_NM,
         C.DESCRIPTION_TEXT
  FROM   TYPE_DEF A, OBJ_DESC B,
         DESCRIPTION C
  WHERE  B.OBJECT_T = 'TYP'
  AND    B.OBJECT_S = A.TYPE_DEF_S
  AND    C.DESCRIPTION_S = B.DESCRIPTION_S
);
CREATE VIEW ATTRIBUTE_DESC AS
(
  SELECT A.SOURCE_S, A.ATTRIBUTE_S, A.ATTRIBUTE_NM,
         A.PARENT_ENT, C.DESCRIPTION_TEXT
  FROM   ATTRIBUTE A, OBJ_DESC B,
         DESCRIPTION C
  WHERE  B.OBJECT_T = 'ATT'
  AND    B.OBJECT_S = A.ATTRIBUTE_S
  AND    C.DESCRIPTION_S = B.DESCRIPTION_S
);
CREATE VIEW RULES_DESC AS
(
  SELECT A.RULES_S, A.RULE_LABEL, A.RULE_TYPE,
         C.DESCRIPTION_TEXT
  FROM   RULES A, OBJ_DESC B,
         DESCRIPTION C
  WHERE  B.OBJECT_T = 'RUL'
  AND    B.OBJECT_S = A.RULES_S
  AND    C.DESCRIPTION_S = B.DESCRIPTION_S
);
CREATE VIEW TABLE_DESC AS
(
  SELECT A.TABLE_TYPE, A.TABLE_DEF_S, A.TABLE_DEF_NM,
         C.DESCRIPTION_TEXT
  FROM   TABLE_DEF A, OBJ_DESC B,
         DESCRIPTION C, PROJECTION_MAP D
  WHERE  D.MAP_TARGET_S = A.TABLE_DEF_S
  AND    D.REF_PROJ_METH IN ('ent_table','ent_n_in_one')
  AND    B.OBJECT_S = D.MAP_SOURCE_S
  AND    B.OBJECT_T = 'ENT'
  AND    C.DESCRIPTION_S = B.DESCRIPTION_S
);
CREATE VIEW COLUMN_DESC AS
(
  SELECT B.TABLE_DEF_S, B.TABLE_DEF_NM,
         A.COLUMN_DEF_S, A.COLUMN_DEF_NM, A.TYPE_CODE,
         D.DESCRIPTION_TEXT
  FROM   COLUMN_DEF A, TABLE_DEF B, OBJ_DESC C, DESCRIPTION D,
         COLUMN_GROUP E, ATT_COL_GRP_MAP F
  WHERE  A.PARENT_TABLE_S = B.TABLE_DEF_S
  AND    E.COLUMN_DEF_S = A.COLUMN_DEF_S
  AND    F.COLUMN_GROUP_S = E.HEAD_COL_GRP_S
  AND    F.ATTRIBUTE_S = C.OBJECT_S
  AND    C.OBJECT_T = 'ATT'
  AND    D.DESCRIPTION_S = C.DESCRIPTION_S
);
CREATE VIEW CHANGE_REQUEST_DESC AS
(
  SELECT A.CHANGE_REQUEST_S, A.REQUEST_NR, A.TITLE, C.DESCRIPTION_TEXT
  FROM   DESCRIPTION C, OBJ_DESC B, CHANGE_REQUEST A
  WHERE  B.OBJECT_T = 'CHR'
  AND    B.OBJECT_S = A.CHANGE_REQUEST_S
  AND    B.DESCRIPTION_S = C.DESCRIPTION_S
);
CREATE VIEW CHANGE_DESC AS
(
  SELECT A.CHANGE_S, A.TITLE, PARENT_REQUEST, TYPE_OF_CHANGE, C.DESCRIPTION_TEXT
  FROM   DESCRIPTION C, OBJ_DESC B, CHANGE A
  WHERE  B.OBJECT_T = 'CHG'
  AND    B.OBJECT_S = A.CHANGE_S
  AND    B.DESCRIPTION_S = C.DESCRIPTION_S
);
exit;
